"""
Django settings for waveqc project.

Generated by 'django-admin startproject' using Django stable.1.

For more information on this file, see
https://docs.djangoproject.com/en/stable/topics/settings/

For the full list of settings and their values, see
https://docs.djangoproject.com/en/stable/ref/settings/
"""

from pathlib import Path

import django_stubs_ext
import environ
import sentry_sdk
from sentry_sdk.integrations.celery import CeleryIntegration

django_stubs_ext.monkeypatch()

# Build paths inside the project like this: BASE_DIR / 'subdir'.
BASE_DIR = Path(__file__).resolve().parent.parent

# Take environment variables form system and from .env file
# See https://django-environ.readthedocs.io/en/latest/quickstart.html
env = environ.Env()
environ.Env.read_env(Path(BASE_DIR / ".env"))

# Initialize Sentry
# See https://docs.sentry.io/platforms/python/integrations/django/
sentry_sdk.init(
    dsn=env.str("SENTRY_DSN"),
    environment=env.str("SENTRY_ENVIRONMENT"),
    traces_sample_rate=1.0,
    profiles_sample_rate=env.float("SENTRY_PROFILES_SAMPLE_RATE"),
    integrations=[
        CeleryIntegration(monitor_beat_tasks=True),
    ],
)

# Quick-start development settings
# See https://docs.djangoproject.com/en/stable/howto/deployment/checklist/
SECRET_KEY = env.str("SECRET_KEY")
DEBUG: bool = env.bool("DEBUG")
ALLOWED_HOSTS = env.list("ALLOWED_HOSTS")

# Django Debug DebugToolbar
# See https://django-debug-toolbar.readthedocs.io/en/latest/installation.html
INTERNAL_IPS = [
    "127.0.0.1",
]

# Https related settings
# See https://docs.djangoproject.com/en/stable/howto/deployment/checklist/#https
CSRF_TRUSTED_ORIGINS = env.list("CSRF_TRUSTED_ORIGINS")
CSRF_COOKIE_SECURE = env.bool("CSRF_COOKIE_SECURE")
SESSION_COOKIE_SECURE = env.bool("SESSION_COOKIE_SECURE")
# See https://docs.djangoproject.com/en/5.0/ref/middleware/#ssl-redirect
SECURE_SSL_REDIRECT = env.bool("SECURE_SSL_REDIRECT")
# See https://docs.djangoproject.com/en/5.0/ref/middleware/#http-strict-transport-security
SECURE_HSTS_SECONDS = env.int("SECURE_HSTS_SECONDS")
SECURE_HSTS_INCLUDE_SUBDOMAINS = env.bool("SECURE_HSTS_INCLUDE_SUBDOMAINS")
SECURE_HSTS_PRELOAD = env.bool("SECURE_HSTS_PRELOAD")
SECURE_PROXY_SSL_HEADER = env.tuple("SECURE_PROXY_SSL_HEADER", default=None)

# Application definition
INSTALLED_APPS = [
    "whitenoise.runserver_nostatic",
    "quality.apps.QualityConfig",
    "django.contrib.admin",
    "django.contrib.auth",
    "django.contrib.contenttypes",
    "django.contrib.humanize",
    "django.contrib.sessions",
    "django.contrib.messages",
    "django.contrib.staticfiles",
    "django_extensions",
]

MIDDLEWARE = [
    "django.middleware.gzip.GZipMiddleware",
    "django.middleware.security.SecurityMiddleware",
    "whitenoise.middleware.WhiteNoiseMiddleware",
    "django.contrib.sessions.middleware.SessionMiddleware",
    "django.middleware.common.CommonMiddleware",
    "django.middleware.csrf.CsrfViewMiddleware",
    "django.contrib.auth.middleware.AuthenticationMiddleware",
    "django.contrib.messages.middleware.MessageMiddleware",
    "django.middleware.clickjacking.XFrameOptionsMiddleware",
]

if DEBUG:
    INSTALLED_APPS.append("debug_toolbar")
    MIDDLEWARE.insert(1, "debug_toolbar.middleware.DebugToolbarMiddleware")

ROOT_URLCONF = "waveqc.urls"

TEMPLATES = [
    {
        "BACKEND": "django.template.backends.django.DjangoTemplates",
        "DIRS": [BASE_DIR / "templates"],
        "APP_DIRS": True,
        "OPTIONS": {
            "context_processors": [
                "django.template.context_processors.debug",
                "django.template.context_processors.request",
                "django.contrib.auth.context_processors.auth",
                "django.contrib.messages.context_processors.messages",
            ],
        },
    },
]

STORAGES = {
    "staticfiles": {
        "BACKEND": "whitenoise.storage.CompressedManifestStaticFilesStorage",
    },
}

WSGI_APPLICATION = "waveqc.wsgi.application"


# Database
# https://docs.djangoproject.com/en/stable/ref/settings/#databases
DATABASES = {
    "default": {
        "ENGINE": env.str("DATABASE_ENGINE"),
        "NAME": env.str("DATABASE_NAME"),
        "USER": env.str("DATABASE_USER"),
        "PASSWORD": env.str("DATABASE_PASSWORD"),
        "HOST": env.str("DATABASE_HOST"),
        "PORT": env.int("DATABASE_PORT"),
        "CONN_MAX_AGE": env.int("DATABASE_CONN_MAX_AGE"),
        "CONN_HEALTH_CHECKS": env.bool("DATABASE_CONN_HEALTH_CHECKS"),
    }
}


# Password validation
# https://docs.djangoproject.com/en/stable/ref/settings/#auth-password-validators
AUTH_PASSWORD_VALIDATORS = [
    {
        "NAME": "django.contrib.auth.password_validation.UserAttributeSimilarityValidator",  # noqa: E501
    },
    {
        "NAME": "django.contrib.auth.password_validation.MinimumLengthValidator",
    },
    {
        "NAME": "django.contrib.auth.password_validation.CommonPasswordValidator",
    },
    {
        "NAME": "django.contrib.auth.password_validation.NumericPasswordValidator",
    },
]


# Internationalization
# https://docs.djangoproject.com/en/stable/topics/i18n/
LANGUAGE_CODE = "en-us"
TIME_ZONE = "UTC"
USE_I18N = True
USE_TZ = True

# Static files (CSS, JavaScript, Images)
# https://docs.djangoproject.com/en/stable/howto/static-files/
STATIC_URL = "static/"
STATIC_ROOT = env.path("STATIC_ROOT")

# Default primary key field type
# https://docs.djangoproject.com/en/stable/ref/settings/#default-auto-field
DEFAULT_AUTO_FIELD = "django.db.models.BigAutoField"

# Shell_plus configuration
# https://django-extensions.readthedocs.io/en/latest/shell_plus.html#configuration
SHELL_PLUS = "ipython"
SHELL_PLUS_PRINT_SQL = True

AMQP_USER = env.str("AMQP_USER")
AMQP_PASSWORD = env.str("AMQP_PASSWORD")
AMQP_URL = env.str("AMQP_URL")
AMQP_PORT = env.int("AMQP_PORT")
AMQP_VHOST = env.str("AMQP_VHOST")

RT_SERVER_URL = env.str("RT_SERVER_URL")

# Celery configuration
# https://docs.celeryq.dev/en/stable/userguide/configuration.html#configuration
CELERY_BROKER_URL = (
    f"amqp://{AMQP_USER}:{AMQP_PASSWORD}@{AMQP_URL}:{AMQP_PORT}/{AMQP_VHOST}"
)
CELERY_RESULT_BACKEND = env.cache_url("CELERY_RESULT_BACKEND")
CELERY_BEAT_SCHEDULE_FILENAME = env.path("CELERY_BEAT_SCHEDULE_FILENAME")
CELERY_WORKER_MAX_TASKS_PER_CHILD = env.int("CELERY_WORKER_MAX_TASKS_PER_CHILD")
CELERY_WORKER_PREFETCH_MULTIPLIER = env.int("CELERY_WORKER_PREFETCH_MULTIPLIER")
CELERY_TASK_ACKS_LATE = True
CELERY_TASK_REJECT_ON_WORKER_LOST = True

# WaveQC specific configuration
WAVEQC_FDSN_CLIENT = env.str("WAVEQC_FDSN_CLIENT")
WAVEQC_STATIONXML_STORAGE_PATH = env.path("WAVEQC_STATIONXML_STORAGE_PATH")
WAVEQC_MSEED_STORAGE_PATH = env.path("WAVEQC_MSEED_STORAGE_PATH")
WAVEQC_SCHEDULE = env.str("WAVEQC_SCHEDULE")
